//////////////////////////////////////////////////////////////////////
// scene.cpp: implementation of the scene class.
//
//////////////////////////////////////////////////////////////////////
#include "scene.h"
//////////////////////////////////////////////////////////////////////
// Tu je vsetko co sa kresli

void scene::DrawGLScene()
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	//cisti buffer v aktualnom viewporte a to iba color a hlbkovy bit
	glLoadIdentity();
	
	GetCursorPos(&MouseBod);
	mouse_x = MouseBod.x;
	mouse_y = screen_y-1-MouseBod.y;
	
	if(keys['L'] && keys[VK_CONTROL]){ english = !english; keys['L']=0; }
	if(keys['L']){	svetlo = !svetlo; keys['L']=0; }
	
	if(keys['T'])			// nastavuje aka textura sa bude nastavovat
	{
		nastav_tex=!nastav_tex;
		keys['T']=0;
	}
	if(keys[VK_ADD])
	{
		if(nastav_tex==0)
		{
			tex_base++;
			if(tex_base>=pocet_base_textur)tex_base=pocet_base_textur-1;
		}
		else if(nastav_tex==1)
		{
			tex_bump++;
			if(tex_bump>=pocet_bump_textur)tex_bump=pocet_bump_textur-1;
		}
		keys[VK_ADD]=0;
	}
	else if(keys[VK_SUBTRACT])
	{
		if(nastav_tex==0)
		{
			tex_base--;
			if(tex_base<0)tex_base=0;
		}
		else if(nastav_tex==1)
		{
			tex_bump--;
			if(tex_bump<0)tex_bump=0;
		}
		keys[VK_SUBTRACT]=0;
	}

	if(keys['M'])
	{
		multi = !multi;
		keys['M']=0;
	}
	if(keys['1'])     obrazovka=1;
	else if(keys['2'])obrazovka=2;
	else if(keys['3'])obrazovka=3;
	else if(keys['4'])obrazovka=4;

	switch(obrazovka)
	{
	case 1:
		bump_mapping_smerove_svetlo();
		break;
	case 2:
		svetlo_v_suradniciach_objektu();
		break;
	case 3:
		bludisko();
		break;
	case 4:
		kresli_mars();
		break;
	}
}
static inline void Stvorec60(void);
static inline void Stvorec60_b(float x,float y);
static inline void Stvorec60_m_b(float x,float y);
static inline void Stvorec100(void);

static inline void Stvorec256(void);
static inline void Stvorec256_b(float x,float y);
static inline void Stvorec256_m(void);
static inline void Stvorec256_m_b(float x,float y);

static inline void Stvorec512(void);
static inline void Stvorec512_b(float x,float y);

void scene::bump_mapping_smerove_svetlo(void)
{
	if(keys[VK_LEFT])bump_x-=0.5f/fps;
	else if(keys[VK_RIGHT])bump_x+=0.5f/fps;

	if(keys[VK_UP])bump_y+=0.5f/fps;
	else if(keys[VK_DOWN])bump_y-=0.5f/fps;

	if(keys['R']){	bump_x = 0; bump_y = 0; }
	if(keys['I']){	bump_x = -bump_x; bump_y = -bump_y; keys['I']=0;}
	if(keys['A']){	anim = !anim; keys['A'] = 0; }
	if(anim)
	{
		float pom;
		bump_angle += 50.f/fps;

		if(bump_angle>360.0f)bump_angle-= 360.0f;

		pom = (float) sqrt(bump_x*bump_x + bump_y*bump_y);
		bump_x = pom * (float)sin(PI180*bump_angle);
		bump_y = pom * (float)cos(PI180*bump_angle);
	}


	if(multi&&multitextureSupported)vysvetlenie_2pass();
	else vysvetlenie_3pass();

	// textury kreslene hore
	glBindTexture(GL_TEXTURE_2D,base[tex_base] );
	glLoadIdentity();	
	glTranslatef(240,400,0);
	Stvorec100();

	glBindTexture(GL_TEXTURE_2D,bump[tex_bump] );
	glLoadIdentity();	
	glTranslatef(360,400,0);
	Stvorec100();

	glBindTexture(GL_TEXTURE_2D,bump_shift[tex_bump] );
	glLoadIdentity();	
	glTranslatef(550,400,0);
	Stvorec100();

	glBindTexture(GL_TEXTURE_2D,bump_inv[tex_bump] );
	glLoadIdentity();	
	glTranslatef(670,400,0);
	Stvorec100();

	glColor4f(1,1,1,1);
	glLoadIdentity();
	glDisable(GL_TEXTURE_2D);
	if(nastav_tex)		// bump textura
	{
		glBegin(GL_LINE_LOOP);
		glVertex2i(355,395);
		glVertex2i(465,395);
		glVertex2i(465,505);
		glVertex2i(355,505);
		glEnd();

	}
	else				// base textura
	{
		glBegin(GL_LINE_LOOP);
		glVertex2i(235,395);
		glVertex2i(345,395);
		glVertex2i(345,505);
		glVertex2i(235,505);
		glEnd();
	}
	Kurzor();
	glEnable(GL_TEXTURE_2D);
	
	font0->Begin();
	fps = 1.0f / timer0.GetTime();
	timer0.Reset();

	fps_counter.GetAvgFps(1.f/fps,0.2f);
	gcvt( (double)fps_counter.avg_fps, 4, text);
	font0->Print(0,0,text,0);

	font0->Print(0,1,"Bump x:",0);
	gcvt( (double)bump_x, 4, text);
	font0->Print(8,1,text,0);
	
	font0->Print(0,2,"Bump y:",0);
	gcvt( (double)bump_y, 4, text);
	font0->Print(8,2,text,0);

	font0->Print(0,3,"Bump angle:",0);
	gcvt( (double)bump_angle, 4, text);
	font0->Print(13,3,text,0);

	if(english)
	{
		font0->Print(0,4,"Shift:",0);
		gcvt( sqrt(bump_x*bump_x + bump_y*bump_y), 4, text);
		font0->Print(13,4,text,0);

		font0->Print_xy_scale(160,573,"Explanation how work bump-mapping",0,1.5f,1.5f);
		font0->Print_xy_scale(160,554," - directional light",0,1.2f,1.2f);
		
		font0->Print_xy_scale(240,530,"texture on disk",0,1.3f,1.3f);
		font0->Print_xy_scale(240,510,"base",0,1.0f,1.0f);
		font0->Print_xy_scale(360,510,"heinght map",0,1.0f,1.0f);

		font0->Print_xy_scale(550,540,"created textures",0,1.3f,1.3f);
		font0->Print_xy_scale(550,520,"shift -",0,1.0f,1.0f);
		font0->Print_xy_scale(550,505,"0.5 brightness",0,0.7f,1.0f);
		font0->Print_xy_scale(670,510,"inv and shift",0,0.8f,1.0f);
	}
	else
	{
		font0->Print(0,4,"Posun:",0);
		gcvt( sqrt(bump_x*bump_x + bump_y*bump_y), 4, text);
		font0->Print(13,4,text,0);

		font0->Print_xy_scale(160,573,"Vysvetlenie ako funguje bump-mapping",0,1.5f,1.5f);
		font0->Print_xy_scale(160,554," - smerove svetlo - svetlo svietiace z nekonecna",0,1.2f,1.2f);
		
		font0->Print_xy_scale(240,530,"textury na disku",0,1.3f,1.3f);
		font0->Print_xy_scale(240,510,"zakladna",0,1.0f,1.0f);
		font0->Print_xy_scale(360,510,"vyskova mapa",0,1.0f,1.0f);

		font0->Print_xy_scale(550,530,"vytvorene textury",0,1.3f,1.3f);
		font0->Print_xy_scale(550,510,"shift-0.5 jas",0,0.8f,1.0f);
		font0->Print_xy_scale(670,510,"inv and shift",0,0.8f,1.0f);
	}

	glColor3f(1,1,1);
	
	if(keys['H'])							// zobrazenie helpu
	{
		int i=3;
		glDisable(GL_TEXTURE_2D);
		glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
		glColor4f(0,0,0,0.8f);
		glLoadIdentity();
		glBegin(GL_QUADS);
			glVertex2i(80,295);
			glVertex2i(800,295);
			glVertex2i(800,555);
			glVertex2i(80,555);
		glEnd();
		glColor4f(1,1,1,1);
		glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_COLOR);
		glEnable(GL_TEXTURE_2D);

		if(english)
		{
			font0->Print(15,i++,"Program: Bump-mapping - explanation",0);
			glColor3f(0.9f,0.9f,1.0f);
			font0->Print(8,i++,"Programmer: Marek Mizanin - www.mizanin.szm.sk",0);
			glColor3f(1.0f,1.0f,1.0f);
			font0->Print(10,i++,"Controls:",0);
			font0->Print(15,i++,"1 - switch to explanation how work emboss bump-mapping",1);
			font0->Print(15,i++,"2 - switch to example bump-mapping with point light",1);
			font0->Print(15,i++,"3 - switch to labyrinth with bump-mapping",1);
			font0->Print(15,i++,"4 - planet with bump-mapping",1);
			font0->Print(15,i++,"T - change how texture you are setting",1);
			font0->Print_scale(15,i++,"+ a - on numerical keyboard - change texture that is in frame",1,0.85f,1);
			font0->Print(15,i++,"E - switch off bump-mapping",1);
			font0->Print(15,i++,"M - on/off multitexturing",1);
			font0->Print(15,i++,"A - on/off animation",1);
			font0->Print(15,i++,"R - reset x and y shift",1);
			font0->Print(15,i++,"arrow - set x and y shift",1);
		}
		else
		{
			font0->Print(15,i++,"Program: Bump-mapping - vysvetlenie",0);
			glColor3f(0.9f,0.9f,1.0f);
			font0->Print(8,i++,"Naprogramoval: Marek Mizanin - www.mizanin.szm.sk",0);
			glColor3f(1.0f,1.0f,1.0f);
			font0->Print(10,i++,"Pouzivane klavesy:",0);
			font0->Print(15,i++,"1 - prepne na vysvetlenie ako funguje emboss bump-mapping",1);
			font0->Print(15,i++,"2 - prepne na ukazku bump-mappingu so bodovym svetlom",1);
			font0->Print(15,i++,"3 - prepne bludisko s bump-mappingom",1);
			font0->Print(15,i++,"4 - planeta s bump-mappingom",1);
			font0->Print(15,i++,"T - prepina aku texturu budeme nastavovat",1);
			font0->Print_scale(15,i++,"+ a - na numerickej klavesnici - meni texturu ktora je v ramceku",1,0.85f,1);
			font0->Print(15,i++,"E - vypne bump-mapping, pre porovnanie farieb",1);
			font0->Print(15,i++,"M - zapne/vypne multitexturing",1);
			font0->Print(15,i++,"A - zapne/vypme animaciu",1);
			font0->Print(15,i++,"R - vynuluje posunutie x a y",1);
			font0->Print(15,i++,"sipky - nastavuju posunutie x a y",1);
		}

		font0->Print(15,i++,"H - help",1);
	}
	font0->End();
}

void scene::vysvetlenie_3pass(void)
{
//--3. krok BUMP MAPPING a vysvetlenie--------------------------
	// -------------- BUMP MAPPING -----------------------------
	// 1-pass, vykreslenie bump_shift textury
	glBindTexture(GL_TEXTURE_2D,bump_shift[tex_bump] );
	glLoadIdentity();
	glTranslatef(540,10,0);					// kreslime vlavo dole
	Stvorec256();

	// 2-pass, vykreslenie pricitanim posunutej bump_inv testury
	glBindTexture(GL_TEXTURE_2D,bump_inv[tex_bump] );
	glBlendFunc(GL_ONE,GL_ONE);				// scitavanie
	glEnable(GL_BLEND);
	Stvorec256_b(bump_x,bump_y);			// kreslime posunutu texturu
	glDisable(GL_BLEND);
	
	// 3-pass, vynasobenie 2* so zakladnou texturov
	glBindTexture(GL_TEXTURE_2D,base[tex_base] );
	glBlendFunc(GL_DST_COLOR,GL_SRC_COLOR);		// nasobenie 2* (kreslene*nakreslene(GL_DST_COLOR))+(nakreslene*kreslene(GL_SRC_COLOR))=2*(kreslene*nakreslene)
	if(!keys['E'])glEnable(GL_BLEND);
	Stvorec256();
	glDisable(GL_BLEND);
	// -- END ------------ BUMP MAPPING -----------------------------

	// svetlo
	glBindTexture(GL_TEXTURE_2D, t_svetlo );
	glLoadIdentity();	
	glTranslatef(638+128.f*(float)sin(PI180*bump_angle),108+128.f*(float)cos(PI180*bump_angle),0);
	glBlendFunc(GL_ONE, GL_ONE_MINUS_SRC_COLOR);
	glEnable(GL_BLEND);
	Stvorec60();
	glDisable(GL_BLEND);

	// obrazky pre ukazku co robi 3. krok, velkost 60
	glBindTexture(GL_TEXTURE_2D,base[tex_base] );
	glLoadIdentity();
	glTranslatef(540,300,0);
	Stvorec60();
	// 2.krok,
	// 2-pass,2.krok BUMP MAPPING -----------------------------
	// 1-pass, vykreslenie bump_shift textury
	glBindTexture(GL_TEXTURE_2D,bump_shift[tex_bump] );
	glLoadIdentity();
	glTranslatef(700,300,0);
	Stvorec60();

	// 2-pass, vykreslenie pricitanie posunutej bump_inv testury
	glBindTexture(GL_TEXTURE_2D,bump_inv[tex_bump] );
	glBlendFunc(GL_ONE,GL_ONE);				// scitavanie
	glEnable(GL_BLEND);
	Stvorec60_b(bump_x,bump_y);
	glDisable(GL_BLEND);
	// --END-- 2-pass,2.krok BUMP MAPPING -----------------------------
//--------------------------------------------------------------------

//--2. krok BUMP MAPPING a vysvetlenie--------------------------

	// 2-pass,2.krok BUMP MAPPING -----------------------------
	// 1-pass, vykreslenie bump_shift textury
	glBindTexture(GL_TEXTURE_2D,bump_shift[tex_bump] );
	glLoadIdentity();
	glTranslatef(272,10,0);
	Stvorec256();

	// 2-pass, vykreslenie pricitanie posunutej bump_inv testury
	glBindTexture(GL_TEXTURE_2D,bump_inv[tex_bump] );
	glBlendFunc(GL_ONE,GL_ONE);				// scitavanie
	glEnable(GL_BLEND);
	Stvorec256_b(bump_x,bump_y);
	glDisable(GL_BLEND);
	// --END-- 2-pass,2.krok BUMP MAPPING -----------------------------

	// svetlo pre 2.krok
	glBindTexture(GL_TEXTURE_2D, t_svetlo );
	glLoadIdentity();	
	glTranslatef(370+128.f*(float)sin(PI180*bump_angle),108+128.f*(float)cos(PI180*bump_angle),0);
	glBlendFunc(GL_ONE, GL_ONE_MINUS_SRC_COLOR);
	glEnable(GL_BLEND);
	Stvorec60();
	glDisable(GL_BLEND);

	// obrazky pre ukazku co robi 2. krok, velkost 60
	glBindTexture(GL_TEXTURE_2D,bump_shift[tex_bump] );
	glLoadIdentity();	
	glTranslatef(272,300,0);
	Stvorec60();

	// obrazky pre ukazku co robi 2. krok, velkost 60
	glBindTexture(GL_TEXTURE_2D,bump_inv[tex_bump] );
	glLoadIdentity();	
	glTranslatef(452,300,0);
	Stvorec60();
//--------------------------------------------------------------------
//--1. krok BUMP MAPPING a vysvetlenie--------------------------
	// 1-pass. 1.krok BUMP MAPPING -----------------------------
	// 1-pass, vykreslenie bump_shift textury
	glBindTexture(GL_TEXTURE_2D,bump_shift[tex_bump] );
	glLoadIdentity();
	glTranslatef(4,10,0);
	Stvorec256();
	// --END-- 1-pass. 1.krok BUMP MAPPING -----------------------------
	
	// obrazky pre ukazku co robi 1. krok, velkost 60
	glBindTexture(GL_TEXTURE_2D,bump_shift[tex_bump] );
	glLoadIdentity();	
	glTranslatef(40,300,0);
	Stvorec60();
//--------------------------------------------------------------------

	glEnable(GL_TEXTURE_2D);
	
	font0->Begin();

	font0->Print_xy_scale(250,370,"3-pass BUMP-MAPPING",0,1.5f,1.5f);
	font0->Print_xy_scale( 84,270,"1-pass",0,1.5f,1.5f);
	font0->Print_xy_scale(120,313,"=",0,1.8f,1.8f);
	font0->Print_xy_scale(352,270,"2-pass",0,1.5f,1.5f);
	font0->Print_xy_scale(336,318,english ?"+ shifted" :"+ posunuta",0,1.0f,1.0f);
	font0->Print_xy_scale(510,313,"=",0,1.8f,1.8f);

	font0->Print_xy_scale(620,270,"3-pass",0,1.5f,1.5f);
	font0->Print_xy_scale(610,313,"* 2*",0,1.8f,1.8f);
	font0->Print_xy_scale(765,313,"=",0,1.8f,1.8f);

	glColor3f(1,0,0);
	if(multitextureSupported)
	{
		font0->Print(0,5,"Multitexturing",0);
		font0->Print(0,6,english ? "supported - 'M'" :"podporovany - 'M'",0);
	}
	else
	{
		font0->Print(0,5,"Multitexturing",0);
		font0->Print(0,6,english ? "unssupported :-(":"nepodporovany :-(",0);
	}
	glColor3f(1,1,1);
	//font0->End();		// bude sa volat neskor
}

void scene::vysvetlenie_2pass(void)
{
//--2. krok BUMP MAPPING s multitexturing a vysvetlenie--------------------------
	// -------------- BUMP MAPPING s multitexturing -----------------------------
	// 1-pass, vynasobenie bump_shift s posunutov bump_inv texturov
	glLoadIdentity();
	glTranslatef(540,10,0);
	
	// TEXTURE-UNIT #0		
	glActiveTextureARB(GL_TEXTURE0_ARB);			// aktivujeme 0 jednotku
	glEnable(GL_TEXTURE_2D);						// povolime texturovanie
	glBindTexture(GL_TEXTURE_2D,bump_shift[tex_bump] );	// nastavime texturu
	glTexEnvi( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);	// nastavime rezim na masobenie

	// TEXTURE-UNIT #1:
	glActiveTextureARB(GL_TEXTURE1_ARB);			// aktivuje 1 jednotku
	glEnable(GL_TEXTURE_2D);
	glBindTexture(GL_TEXTURE_2D,bump_inv[tex_bump] );
	glTexEnvi( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_ADD);	// nastavime scitavanie
	Stvorec256_m_b(bump_x,bump_y);

	//FINISH MULTITEXTURING
	glActiveTextureARB(GL_TEXTURE1_ARB);
	glDisable(GL_TEXTURE_2D);						// vypneme 1 jednotku
	glActiveTextureARB(GL_TEXTURE0_ARB);
	//FINISH MULTITEXTURING
	glTexEnvi( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE,  GL_MODULATE);

	// 2-pass, vynasobenie 2* so zakladnou texturov
	glBindTexture(GL_TEXTURE_2D,base[tex_base] );
	glBlendFunc(GL_DST_COLOR,GL_SRC_COLOR);
	if(!keys['E'])glEnable(GL_BLEND);
	Stvorec256();
	glDisable(GL_BLEND);
	// -- END ------------ BUMP MAPPING -----------------------------

	// svetlo
	glBindTexture(GL_TEXTURE_2D, t_svetlo );
	glLoadIdentity();	
	glTranslatef(638+128.f*(float)sin(PI180*bump_angle),108+128.f*(float)cos(PI180*bump_angle),0);
	glBlendFunc(GL_ONE, GL_ONE_MINUS_SRC_COLOR);
	glEnable(GL_BLEND);
	Stvorec60();
	glDisable(GL_BLEND);

	// obrazky pre ukazku co robi 2. krok, velkost 60
	glBindTexture(GL_TEXTURE_2D,base[tex_base] );
	glLoadIdentity();	
	glTranslatef(540,300,0);
	Stvorec60();
	// 1.krok,
	// 1-pass,1.krok BUMP MAPPING -----------------------------
	// 1-pass, vynasobenie bump_shift s posunutov bump_inv texturov
	glBindTexture(GL_TEXTURE_2D,bump_shift[tex_bump] );
	glLoadIdentity();
	glTranslatef(700,300,0);
	// TEXTURE-UNIT #0
	glActiveTextureARB(GL_TEXTURE0_ARB);
	glEnable(GL_TEXTURE_2D);
	glBindTexture(GL_TEXTURE_2D,bump_shift[tex_bump] );
	glTexEnvi( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);

	// TEXTURE-UNIT #1:
	glActiveTextureARB(GL_TEXTURE1_ARB);
	glEnable(GL_TEXTURE_2D);
	glBindTexture(GL_TEXTURE_2D,bump_inv[tex_bump] );
	glTexEnvi( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_ADD);
	Stvorec60_m_b(bump_x,bump_y);

	//FINISH MULTITEXTURING
	glActiveTextureARB(GL_TEXTURE1_ARB);
	glDisable(GL_TEXTURE_2D);
	glActiveTextureARB(GL_TEXTURE0_ARB);
	//FINISH MULTITEXTURING
	glTexEnvi( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE,  GL_MODULATE);

	// --END-- 1-pass,1.krok BUMP MAPPING -----------------------------
//--------------------------------------------------------------------

//--1. krok BUMP MAPPING a vysvetlenie--------------------------
	// -------------- BUMP MAPPING -----------------------------
	// 1-pass, vynasobenie bump_shift s posunutov bump_inv texturov
	glLoadIdentity();
	glTranslatef(272,10,0);
	
	// TEXTURE-UNIT #0		
	glActiveTextureARB(GL_TEXTURE0_ARB);
	glEnable(GL_TEXTURE_2D);
	glBindTexture(GL_TEXTURE_2D,bump_shift[tex_bump] );
	glTexEnvi( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);

	// TEXTURE-UNIT #1:
	glActiveTextureARB(GL_TEXTURE1_ARB);
	glEnable(GL_TEXTURE_2D);
	glBindTexture(GL_TEXTURE_2D,bump_inv[tex_bump] );
	glTexEnvi( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_ADD);
	Stvorec256_m_b(bump_x,bump_y);

	//FINISH MULTITEXTURING
	glActiveTextureARB(GL_TEXTURE1_ARB);
	glDisable(GL_TEXTURE_2D);
	glActiveTextureARB(GL_TEXTURE0_ARB);
	//FINISH MULTITEXTURING
	glTexEnvi( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE,  GL_MODULATE);

	// --END-- 1-pass,1.krok BUMP MAPPING -----------------------------

	// svetlo pre 1.krok
	glBindTexture(GL_TEXTURE_2D, t_svetlo );
	glLoadIdentity();	
	glTranslatef(370+128.f*(float)sin(PI180*bump_angle),108+128.f*(float)cos(PI180*bump_angle),0);
	glBlendFunc(GL_ONE, GL_ONE_MINUS_SRC_COLOR);
	glEnable(GL_BLEND);
	Stvorec60();
	glDisable(GL_BLEND);

	// obrazky pre ukazku co robi 1. krok, velkost 60
	glBindTexture(GL_TEXTURE_2D,bump_shift[tex_bump] );
	glLoadIdentity();	
	glTranslatef(272,300,0);
	Stvorec60();

	// obrazky pre ukazku co robi 1. krok, velkost 60
	glBindTexture(GL_TEXTURE_2D,bump_inv[tex_bump] );
	glLoadIdentity();	
	glTranslatef(452,300,0);
	Stvorec60();
//--------------------------------------------------------------------

	glEnable(GL_TEXTURE_2D);
	
	font0->Begin();

	if(english)
		font0->Print_xy_scale(50,370,"2-pass BUMP-MAPPING use multitexturing in 1.pass",0,1.3f,1.5f);
	else
		font0->Print_xy_scale(50,370,"2-pass BUMP-MAPPING pouziva multitexturing v 1.kroku",0,1.3f,1.5f);
	font0->Print_xy_scale(352,270,"1-pass",0,1.5f,1.5f);
	font0->Print_xy_scale(336,318,"+ posunuta",0,1.0f,1.0f);
	font0->Print_xy_scale(510,313,"=",0,1.8f,1.8f);

	font0->Print_xy_scale(620,270,"2-pass",0,1.5f,1.5f);
	font0->Print_xy_scale(610,313,"* 2*",0,1.8f,1.8f);
	font0->Print_xy_scale(765,313,"=",0,1.8f,1.8f);

	glColor3f(1,0,0);
	if(multitextureSupported)
	{
		font0->Print(0,5,"Multitexturing",0);
		font0->Print(0,6,english ? "using" :"pouzivany",0);
	}
	else
	{
		font0->Print(0,5,"Multitexturing",0);
		font0->Print(0,6,english ? "unssupported :-(":"nepodporovany :-(",0);
	}

	glColor3f(1,1,1);
	//font0->End();		// bude sa volat neskor
}

static inline void Stvorec60(void)
{
	glBegin(GL_QUADS);
		glTexCoord2f(0,0);glVertex2i(  0,  0);
		glTexCoord2f(1,0);glVertex2i( 60,  0);
		glTexCoord2f(1,1);glVertex2i( 60, 60);
		glTexCoord2f(0,1);glVertex2i(  0, 60);
	glEnd();
}

static inline void Stvorec60_b(float x,float y)
{
	glBegin(GL_QUADS);
		glTexCoord2f(x/256.0f+0,y/256.0f+0);glVertex2i(   0,  0);
		glTexCoord2f(x/256.0f+1,y/256.0f+0);glVertex2i(  60,  0);
		glTexCoord2f(x/256.0f+1,y/256.0f+1);glVertex2i(  60, 60);
		glTexCoord2f(x/256.0f+0,y/256.0f+1);glVertex2i(   0, 60);
	glEnd();
}

static inline void Stvorec60_m_b(float x,float y)
{
	glBegin(GL_QUADS);
		glMultiTexCoord2fARB(GL_TEXTURE0_ARB,0, 0);	
		glMultiTexCoord2fARB(GL_TEXTURE1_ARB,x/256.0f+0, y/256.0f+0);
//		glNormal3f(-1,-1,0);
			glVertex2i(  0,  0);
		glMultiTexCoord2fARB(GL_TEXTURE0_ARB,1, 0);	
		glMultiTexCoord2fARB(GL_TEXTURE1_ARB,x/256.0f+1, y/256.0f+0);
//		glNormal3f( 1,-1,0);
			glVertex2i( 60,  0);
		glMultiTexCoord2fARB(GL_TEXTURE0_ARB,1, 1);	
		glMultiTexCoord2fARB(GL_TEXTURE1_ARB,x/256.0f+1, y/256.0f+1);
//		glNormal3f(1,1,0);
			glVertex2i( 60, 60);
		glMultiTexCoord2fARB(GL_TEXTURE0_ARB,0, 1);	
		glMultiTexCoord2fARB(GL_TEXTURE1_ARB,x/256.0f+0, y/256.0f+1);		
//		glNormal3f(-1,1,0);
			glVertex2i(  0, 60);
	glEnd();
}

static inline void Stvorec100(void)
{
	glBegin(GL_QUADS);
		glTexCoord2f(0,0);glVertex2i(  0,  0);
		glTexCoord2f(1,0);glVertex2i(100,  0);
		glTexCoord2f(1,1);glVertex2i(100,100);
		glTexCoord2f(0,1);glVertex2i(  0,100);
	glEnd();
}

static inline void Stvorec256(void)
{
	glBegin(GL_QUADS);
		glTexCoord2f(0,0);glVertex2i(   0,  0);
		glTexCoord2f(1,0);glVertex2i( 256,  0);
		glTexCoord2f(1,1);glVertex2i( 256,256);
		glTexCoord2f(0,1);glVertex2i(   0,256);
	glEnd();
}

static inline void Stvorec256_b(float x,float y)
{
	glBegin(GL_QUADS);
		glTexCoord2f( x/256.0f+0, y/256.0f+0);glVertex2i(   0,  0);
		glTexCoord2f( x/256.0f+1, y/256.0f+0);glVertex2i( 256,  0);
		glTexCoord2f( x/256.0f+1, y/256.0f+1);glVertex2i( 256,256);
		glTexCoord2f( x/256.0f+0, y/256.0f+1);glVertex2i(   0,256);
	glEnd();
}

static inline void Stvorec256_m(void)
{
	glBegin(GL_QUADS);
		glMultiTexCoord2fARB(GL_TEXTURE0_ARB,0, 0);	
		glMultiTexCoord2fARB(GL_TEXTURE1_ARB,0, 0);
		glNormal3f(-1,-1,0);
			glVertex2i(  0,  0);
		glMultiTexCoord2fARB(GL_TEXTURE0_ARB,1, 0);	
		glMultiTexCoord2fARB(GL_TEXTURE1_ARB,1, 0);
		glNormal3f( 1,-1,0);
			glVertex2i( 256,  0);
		glMultiTexCoord2fARB(GL_TEXTURE0_ARB,1, 1);	
		glMultiTexCoord2fARB(GL_TEXTURE1_ARB,1, 1);
		glNormal3f(1,1,0);
			glVertex2i( 256, 256);
		glMultiTexCoord2fARB(GL_TEXTURE0_ARB,0, 1);	
		glMultiTexCoord2fARB(GL_TEXTURE1_ARB,0, 1);		
		glNormal3f(-1,1,0);
			glVertex2i(  0, 256);
	glEnd();
}

static inline void Stvorec256_m_b(float x,float y)
{
	glBegin(GL_QUADS);
		glMultiTexCoord2fARB(GL_TEXTURE0_ARB,0, 0);	
		glMultiTexCoord2fARB(GL_TEXTURE1_ARB,x/256.0f+0, y/256.0f+0);
//		glNormal3f(-1,-1,0);
			glVertex2i(  0,  0);
		glMultiTexCoord2fARB(GL_TEXTURE0_ARB,1, 0);	
		glMultiTexCoord2fARB(GL_TEXTURE1_ARB,x/256.0f+1, y/256.0f+0);
//		glNormal3f( 1,-1,0);
			glVertex2i( 256,  0);
		glMultiTexCoord2fARB(GL_TEXTURE0_ARB,1, 1);	
		glMultiTexCoord2fARB(GL_TEXTURE1_ARB,x/256.0f+1, y/256.0f+1);
//		glNormal3f(1,1,0);
			glVertex2i( 256, 256);
		glMultiTexCoord2fARB(GL_TEXTURE0_ARB,0, 1);	
		glMultiTexCoord2fARB(GL_TEXTURE1_ARB,x/256.0f+0, y/256.0f+1);		
//		glNormal3f(-1,1,0);
			glVertex2i(  0, 256);
	glEnd();
}

static inline void Stvorec512(void)
{
	glBegin(GL_QUADS);
		glTexCoord2f(0,0);glVertex2i(   0,  0);
		glTexCoord2f(1,0);glVertex2i( 512,  0);
		glTexCoord2f(1,1);glVertex2i( 512,512);
		glTexCoord2f(0,1);glVertex2i(   0,512);
	glEnd();
}

static inline void Stvorec512_b(float x,float y)
{
	glBegin(GL_QUADS);
		glTexCoord2f(x/256.0f+0,y/256.0f+0);glVertex2i(   0,  0);
		glTexCoord2f(x/256.0f+1,y/256.0f+0);glVertex2i( 512,  0);
		glTexCoord2f(x/256.0f+1,y/256.0f+1);glVertex2i( 512,512);
		glTexCoord2f(x/256.0f+0,y/256.0f+1);glVertex2i(   0,512);
	glEnd();
}
