#include "scene.h"

static float cas=0;
static XYZ str_p,vd_;	// str_p - pozicia strely
static int strela=0;
static float rychlost_strely;

static inline void Stvorec(float *p,float *s,float *t,float *n)
{
	glBegin(GL_QUADS);
		glNormal3fv(n);
		glTexCoord2f(0,0);glVertex3f( p[0], p[1], p[2]);
		glTexCoord2f(1,0);glVertex3f( p[0]+s[0],p[1]+s[1],p[2]+s[2]);
		glTexCoord2f(1,1);glVertex3f( p[0]+s[0]+t[0],p[1]+s[1]+t[1],p[2]+s[2]+t[2]);
		glTexCoord2f(0,1);glVertex3f( p[0]+t[0],p[1]+t[1],p[2]+t[2]);
	glEnd();
}

#define bump_delenie 4
static inline void Stvorec_d(float *p,float *s,float *t,float *n)
{	
	float x,y,krok;

	krok = 1.0f/(float)bump_delenie;
	glBegin(GL_QUADS);
	glNormal3fv(n);
	for(x = 0;x<1.0f;x+=krok)
	{
		for(y = 0;y<1.0f;y+=krok)
		{
			glTexCoord2f(x, y);
			glVertex3f(p[0]+x*s[0]+y*t[0], p[1]+x*s[1]+y*t[1],p[2]+x*s[2]+y*t[2] );
				
			glTexCoord2f((x+krok), y);
			glVertex3f(p[0]+(x+krok)*s[0]+y*t[0], p[1]+(x+krok)*s[1]+y*t[1],p[2]+(x+krok)*s[2]+y*t[2] );

			glTexCoord2f((x+krok), (y+krok));
			glVertex3f(p[0]+(x+krok)*s[0]+(y+krok)*t[0], p[1]+(x+krok)*s[1]+(y+krok)*t[1],p[2]+(x+krok)*s[2]+(y+krok)*t[2] );

			glTexCoord2f(x, (y+krok));
			glVertex3f(p[0]+x*s[0]+(y+krok)*t[0], p[1]+x*s[1]+(y+krok)*t[1],p[2]+x*s[2]+(y+krok)*t[2] );
		}
	}
	glEnd();
}

static void SetUpBumps( float* pos, float *c, float *l, float *s, float *t)
{
	float v[3];					//	vektor z aktualnej pozicie do bodu kde je svetlo
	float lenQ;
		
	v[0]=l[0]-c[0];
	v[1]=l[1]-c[1];
	v[2]=l[2]-c[2];
	lenQ = (float) sqrt(v[0]*v[0]+v[1]*v[1]+v[2]*v[2]);
	v[0]/=lenQ;		v[1]/=lenQ;		v[2]/=lenQ;
	// vypocitame posunutia v smere u a v pre texturu
	pos[0]=(s[0]*v[0]+s[1]*v[1]+s[2]*v[2])*scene::max_emboss;
	pos[1]=(t[0]*v[0]+t[1]*v[1]+t[2]*v[2])*scene::max_emboss;	
}

static inline void Stvorec__d(float *p,float *s,float *t,float *l)
{
	float x,y,krok;
	float c[3],pos[2];

	krok = 1.0f/(float)bump_delenie;

	glBegin(GL_QUADS);
	for(x = 0;x<1.0f;x+=krok)
	{
		for(y = 0;y<1.0f;y+=krok)
		{
			c[0] = p[0]+x*s[0]+y*t[0];
			c[1] = p[1]+x*s[1]+y*t[1];
			c[2] = p[2]+x*s[2]+y*t[2];
			SetUpBumps(pos,c,l,s,t);
			glTexCoord2f(pos[0]+x, pos[1]+y);
			glVertex3fv(c);
				
			c[0] = p[0]+(x+krok)*s[0]+y*t[0];
			c[1] = p[1]+(x+krok)*s[1]+y*t[1];
			c[2] = p[2]+(x+krok)*s[2]+y*t[2];
			SetUpBumps(pos,c,l,s,t);
			glTexCoord2f(pos[0]+(x+krok), pos[1]+y);
			glVertex3fv(c);

			c[0] = p[0]+(x+krok)*s[0]+(y+krok)*t[0];
			c[1] = p[1]+(x+krok)*s[1]+(y+krok)*t[1];
			c[2] = p[2]+(x+krok)*s[2]+(y+krok)*t[2];
			SetUpBumps(pos,c,l,s,t);
			glTexCoord2f(pos[0]+(x+krok), pos[1]+(y+krok));
			glVertex3fv(c);

			c[0] = p[0]+x*s[0]+(y+krok)*t[0];
			c[1] = p[1]+x*s[1]+(y+krok)*t[1];
			c[2] = p[2]+x*s[2]+(y+krok)*t[2];
			SetUpBumps(pos,c,l,s,t);
			glTexCoord2f(pos[0]+x, pos[1]+(y+krok));
			glVertex3fv(c);
		}
	}
	glEnd();
}

static inline void Stvorec_m_d(float *p,float *s,float *t,float *l)
{	
	float x,y,krok;
	float c[3],pos[2];

	krok = 1.0f/(float)bump_delenie;

	glBegin(GL_QUADS);
	for(x = 0;x<1.0f;x+=krok)
	{
		for(y = 0;y<1.0f;y+=krok)
		{
			c[0] = p[0]+x*s[0]+y*t[0];
			c[1] = p[1]+x*s[1]+y*t[1];
			c[2] = p[2]+x*s[2]+y*t[2];
			SetUpBumps(pos,c,l,s,t);
			glMultiTexCoord2fARB(GL_TEXTURE0_ARB,x, y);	
			glMultiTexCoord2fARB(GL_TEXTURE1_ARB,pos[0]+x, pos[1]+y);
			glVertex3fv(c);
				
			c[0] = p[0]+(x+krok)*s[0]+y*t[0];
			c[1] = p[1]+(x+krok)*s[1]+y*t[1];
			c[2] = p[2]+(x+krok)*s[2]+y*t[2];
			SetUpBumps(pos,c,l,s,t);
			glMultiTexCoord2fARB(GL_TEXTURE0_ARB,(x+krok), y);	
			glMultiTexCoord2fARB(GL_TEXTURE1_ARB,pos[0]+(x+krok), pos[1]+y);
			glVertex3fv(c);

			c[0] = p[0]+(x+krok)*s[0]+(y+krok)*t[0];
			c[1] = p[1]+(x+krok)*s[1]+(y+krok)*t[1];
			c[2] = p[2]+(x+krok)*s[2]+(y+krok)*t[2];
			SetUpBumps(pos,c,l,s,t);
			glMultiTexCoord2fARB(GL_TEXTURE0_ARB,(x+krok), (y+krok));	
			glMultiTexCoord2fARB(GL_TEXTURE1_ARB,pos[0]+(x+krok), pos[1]+(y+krok));
			glVertex3fv(c);

			c[0] = p[0]+x*s[0]+(y+krok)*t[0];
			c[1] = p[1]+x*s[1]+(y+krok)*t[1];
			c[2] = p[2]+x*s[2]+(y+krok)*t[2];
			SetUpBumps(pos,c,l,s,t);
			glMultiTexCoord2fARB(GL_TEXTURE0_ARB,x, (y+krok));	
			glMultiTexCoord2fARB(GL_TEXTURE1_ARB,pos[0]+x, pos[1]+(y+krok));
			glVertex3fv(c);
		}
	}
	glEnd();
}

static inline void Stvorec_m_d1(float *p,float *s,float *t,float *n)
{	
	float x,y,krok;
	float c[3];

	krok = 1.0f/(float)bump_delenie;

	glBegin(GL_QUADS);
	glNormal3fv(n);
	for(x = 0;x<1.0f;x+=krok)
	{
		for(y = 0;y<1.0f;y+=krok)
		{
			c[0] = p[0]+x*s[0]+y*t[0];
			c[1] = p[1]+x*s[1]+y*t[1];
			c[2] = p[2]+x*s[2]+y*t[2];
			glMultiTexCoord2fARB(GL_TEXTURE0_ARB,x, y);	
			glMultiTexCoord2fARB(GL_TEXTURE1_ARB,x, y);
			glVertex3fv(c);
				
			c[0] = p[0]+(x+krok)*s[0]+y*t[0];
			c[1] = p[1]+(x+krok)*s[1]+y*t[1];
			c[2] = p[2]+(x+krok)*s[2]+y*t[2];
			glMultiTexCoord2fARB(GL_TEXTURE0_ARB,(x+krok), y);
			glMultiTexCoord2fARB(GL_TEXTURE1_ARB,(x+krok), y);
			glVertex3fv(c);

			c[0] = p[0]+(x+krok)*s[0]+(y+krok)*t[0];
			c[1] = p[1]+(x+krok)*s[1]+(y+krok)*t[1];
			c[2] = p[2]+(x+krok)*s[2]+(y+krok)*t[2];
			glMultiTexCoord2fARB(GL_TEXTURE0_ARB,(x+krok), (y+krok));
			glMultiTexCoord2fARB(GL_TEXTURE1_ARB,(x+krok), (y+krok));
			glVertex3fv(c);

			c[0] = p[0]+x*s[0]+(y+krok)*t[0];
			c[1] = p[1]+x*s[1]+(y+krok)*t[1];
			c[2] = p[2]+x*s[2]+(y+krok)*t[2];
			glMultiTexCoord2fARB(GL_TEXTURE0_ARB,x, (y+krok));
			glMultiTexCoord2fARB(GL_TEXTURE1_ARB,x, (y+krok));
			glVertex3fv(c);
		}
	}
	glEnd();
}

void scene::bludisko_stena(float *p, float *s, float *t, float *n, float *l,int textura)
{
	if(multi&&multitextureSupported)
	{
		// TEXTURE-UNIT #0		
		glActiveTextureARB(GL_TEXTURE0_ARB);			// aktivujeme 0 jednotku
		glEnable(GL_TEXTURE_2D);						// povolime texturovanie
		glBindTexture(GL_TEXTURE_2D,bump_shift[textura] );	// nastavime texturu
		glTexEnvi( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);	// nastavime rezim na masobenie

		// TEXTURE-UNIT #1:
		glActiveTextureARB(GL_TEXTURE1_ARB);			// aktivuje 1 jednotku
		glEnable(GL_TEXTURE_2D);
		glBindTexture(GL_TEXTURE_2D,bump_inv[textura] );
		glTexEnvi( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_ADD);	// nastavime scitavanie
		
		if(svetlo)			// preco je tu toto ? Ani sam neviem, ale bez toho mne robi same nezmyselne ciary
		{
			glEnable(GL_LIGHTING );
			glBegin(GL_QUADS);
			glEnd();
			glPushMatrix();			// tomu ale vobec nechapem, preco tu musi byt Push a Pop matrix ???
			glDisable(GL_LIGHTING );
			glPopMatrix();
		}

		if(bump_)Stvorec_m_d(p,s,t,l);

		//FINISH MULTITEXTURING
		glActiveTextureARB(GL_TEXTURE1_ARB);
		glDisable(GL_TEXTURE_2D);						// vypneme 1 jednotku
		glActiveTextureARB(GL_TEXTURE0_ARB);
		//FINISH MULTITEXTURING
		glTexEnvi( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE,  GL_MODULATE);

		// 2-pass, vynasobenie 2* so zakladnou texturov
		glBindTexture(GL_TEXTURE_2D,base[textura] );
		glBlendFunc(GL_DST_COLOR,GL_SRC_COLOR);		// nasobenie 2* (kreslene*nakreslene(GL_DST_COLOR))+(nakreslene*kreslene(GL_SRC_COLOR))=2*(kreslene*nakreslene)
		if(svetlo)glEnable(GL_LIGHTING );
		if(bump_)glEnable(GL_BLEND);
		if(!emboss)	Stvorec_d(p,s,t,n);
	
		glDisable(GL_BLEND);
		// -- END ------------ BUMP MAPPING -----------------------------
	}
	else
	{
		// -------------- BUMP MAPPING -----------------------------
		// 1-pass, vykreslenie bump_shift textury
		glBindTexture(GL_TEXTURE_2D,bump_shift[textura] );
		if(bump_)
		{
			if(keys['Z'])Stvorec(p,s,t,n);			// kresli sa pomocou jedneho stvorca - je to rychlejsie (ale mne to robi z-buffer problemy)
			else Stvorec_d(p,s,t,n);				// kresli sa pomocou vela stvorcov - tak isto ako v 2-pass
		}

		// 2-pass, vykreslenie pricitanim posunutej bump_inv testury
		glBindTexture(GL_TEXTURE_2D,bump_inv[textura] );
		glBlendFunc(GL_ONE,GL_ONE);				// scitavanie
		glEnable(GL_BLEND);
		if(bump_) Stvorec__d(p,s,t,l);			// kreslime posunutu texturu
		glDisable(GL_BLEND);

		// 3-pass, vynasobenie 2* so zakladnou texturov
		glBindTexture(GL_TEXTURE_2D,base[textura] );
		glBlendFunc(GL_DST_COLOR,GL_SRC_COLOR);		// nasobenie 2* (kreslene*nakreslene(GL_DST_COLOR))+(nakreslene*kreslene(GL_SRC_COLOR))=2*(kreslene*nakreslene)
		if(svetlo)glEnable(GL_LIGHTING );
		if(bump_)glEnable(GL_BLEND);
		if(!emboss)	Stvorec_d(p,s,t,n);
		glDisable(GL_BLEND);
		// -- END ------------ BUMP MAPPING -----------------------------
	}
	glPushMatrix();			// tomu ale vobec nechapem, preco tu musi byt Push a Pop matrix ???
	glDisable(GL_LIGHTING );
	glPopMatrix();

}
#define krabica 0
#define stena_1	2
#define drevo	3
#define kachlicky 4

void scene::bludisko(void)
{
	float p[3],s[3],t[3],n[3],l[4];

	if(keys['P'])
	{
		ciary = !ciary;
		keys['P']=0;
	}
	
	if(keys['E'])
	{
		emboss = !emboss;
		keys['E']=0;
	}

	if(keys['B'])
	{
		bump_ = !bump_;
		keys['B']=0;
	}

	if(cas<=0 && (keys[VK_RETURN] || (keys[VK_LBUTTON] && keys[VK_RBUTTON])) )
	{
		strela = 1;
		vd_.x = c->vd.x;
		vd_.y = c->vd.y;
		vd_.z = c->vd.z;
		str_p.x = c->vp.x+0.2f*vd_.x;;
		str_p.y = c->vp.y+0.2f*vd_.y;
		str_p.z = c->vp.z+0.2f*vd_.z;
		keys[VK_RETURN]=0;
		cas = 0.01f;
		if(keys[VK_SHIFT])rychlost_strely = 10.0f;
		else rychlost_strely=1.0f;
	}

	if(ciary)glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);
	else	 glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);

	Prepni_do_3D();

	c->MoveWorld(fps);					// otocenie sveta
	
	if(!strela)
	{
		l[0] = c->vp.x;
		l[1] = c->vp.y;
		l[2] = c->vp.z;
	}
	else
	{
		l[0] = str_p.x;
		l[1] = str_p.y;
		l[2] = str_p.z;
	}
	l[3] = 1.0f;
	glLightfv( GL_LIGHT0, GL_POSITION, l);
	glLightf( GL_LIGHT0, GL_CONSTANT_ATTENUATION,  0.0f);
	glLightf( GL_LIGHT0, GL_LINEAR_ATTENUATION,    1.0f);
	glLightf( GL_LIGHT0, GL_QUADRATIC_ATTENUATION, 0.0f);

	if(svetlo)		// preco je tu toto ? Ani sam neviem, ale bez toho mne robi same nezmyselne ciary
	{
		glEnable(GL_LIGHTING );
		glBegin(GL_QUADS);
		glEnd();
		glPushMatrix();			// tomu ale vobec nechapem, preco tu musi byt Push a Pop matrix ???
		glDisable(GL_LIGHTING );
		glPopMatrix();
	}

	s[0] = 1;s[1] = 0;s[2] = 0;		// stene pred nami
	t[0] = 0;t[1] = 1;t[2] = 0;
	n[0] = 0;n[1] = 0;n[2] = 1;
	p[0] = 0;p[1] = 0;p[2] = 0;

	// stena v predu
	p[0] =-2; bludisko_stena(p,s,t,n,l,stena_1);
	p[2] =-2;
	
	p[0] = 0; bludisko_stena(p,s,t,n,l,stena_1);
	p[0] = 1; bludisko_stena(p,s,t,n,l,stena_1);
	p[2] =-7;
	p[0] =-1; bludisko_stena(p,s,t,n,l,stena_1);
	p[2] = 0;
	p[0] = 0; bludisko_stena(p,s,t,n,l,krabica);

	// stena za nami (vzadu)
	s[0] =-1;s[1] = 0;s[2] = 0;		// stena za nami
	n[0] = 0;n[1] = 0;n[2] =-1;
	p[2] = 1;
	p[0] =-1; bludisko_stena(p,s,t,n,l,stena_1);
	p[0] = 1; bludisko_stena(p,s,t,n,l,stena_1);
	p[0] = 2; bludisko_stena(p,s,t,n,l,stena_1);
	p[2] = 2;
	p[0] = 0; bludisko_stena(p,s,t,n,l,stena_1);
	p[2] =-1;
	p[0] = 1; bludisko_stena(p,s,t,n,l,krabica);
	
	// stena vpravo
	s[0] = 0;s[1] = 0;s[2] = 1;		// stena vpravo
	n[0] =-1;n[1] = 0;n[2] = 0;

	p[0] = 0;
	p[2] = 1; bludisko_stena(p,s,t,n,l,stena_1);
	p[2] =-3; bludisko_stena(p,s,t,n,l,stena_1);
	p[2] =-4; bludisko_stena(p,s,t,n,l,stena_1);
	p[2] =-5; bludisko_stena(p,s,t,n,l,stena_1);
	p[2] =-6; bludisko_stena(p,s,t,n,l,stena_1);
	p[2] =-7; bludisko_stena(p,s,t,n,l,stena_1);
	p[0] = 2;
	p[2] = 0; bludisko_stena(p,s,t,n,l,stena_1);
	p[2] =-1; bludisko_stena(p,s,t,n,l,stena_1);
	p[2] =-2; bludisko_stena(p,s,t,n,l,stena_1);
	p[0] = 0;
	p[2] =-1; bludisko_stena(p,s,t,n,l,krabica);

	// stena vlavo
	s[0] = 0;s[1] = 0;s[2] =-1;
	n[0] = 1;n[1] = 0;n[2] = 0;
	p[0] =-2;
	p[2] = 1; bludisko_stena(p,s,t,n,l,stena_1);
	p[0] =-1;
	p[2] = 2; bludisko_stena(p,s,t,n,l,stena_1);
	p[2] = 0; bludisko_stena(p,s,t,n,l,stena_1);
	p[2] =-1; bludisko_stena(p,s,t,n,l,stena_1);
	p[2] =-2; bludisko_stena(p,s,t,n,l,stena_1);
	p[2] =-3; bludisko_stena(p,s,t,n,l,stena_1);
	p[2] =-4; bludisko_stena(p,s,t,n,l,stena_1);
	p[2] =-5; bludisko_stena(p,s,t,n,l,stena_1);
	p[2] =-6; bludisko_stena(p,s,t,n,l,stena_1);
	p[0] = 1;
	p[2] = 0; bludisko_stena(p,s,t,n,l,krabica);

	// podlaha
	s[0] = 1;s[1] = 0;s[2] = 0;
	t[0] = 0;t[1] = 0;t[2] =-1;
	n[0] = 0;n[1] = 1;n[2] = 0;

	p[1] = 0;
	p[2] = 2;
	p[0] =-1;bludisko_stena(p,s,t,n,l,kachlicky);
	p[2] = 1;
	p[0] =-2;bludisko_stena(p,s,t,n,l,kachlicky);
	p[0] =-1;bludisko_stena(p,s,t,n,l,kachlicky);
	p[0] = 0;bludisko_stena(p,s,t,n,l,kachlicky);
	p[0] = 1;bludisko_stena(p,s,t,n,l,kachlicky);
	p[2] = 0;
	p[0] =-1;bludisko_stena(p,s,t,n,l,kachlicky);
	p[0] = 1;bludisko_stena(p,s,t,n,l,kachlicky);
	p[2] =-1;
	p[0] =-1;bludisko_stena(p,s,t,n,l,kachlicky);
	p[0] = 0;bludisko_stena(p,s,t,n,l,kachlicky);
	p[0] = 1;bludisko_stena(p,s,t,n,l,kachlicky);
	p[0] =-1;
	p[2] =-2;bludisko_stena(p,s,t,n,l,kachlicky);
	p[2] =-3;bludisko_stena(p,s,t,n,l,kachlicky);
	p[2] =-4;bludisko_stena(p,s,t,n,l,kachlicky);
	p[2] =-5;bludisko_stena(p,s,t,n,l,kachlicky);
	p[2] =-6;bludisko_stena(p,s,t,n,l,kachlicky);

	// strop
	n[0] = 0;n[1] =-1;n[2] = 0;
	
	p[1] = 1;
	p[2] = 2;
	p[0] =-1;bludisko_stena(p,s,t,n,l,drevo);
	p[2] = 1;
	p[0] =-2;bludisko_stena(p,s,t,n,l,drevo);
	p[0] =-1;bludisko_stena(p,s,t,n,l,drevo);
	p[0] = 0;bludisko_stena(p,s,t,n,l,drevo);
	p[0] = 1;bludisko_stena(p,s,t,n,l,drevo);
	p[2] = 0;
	p[0] =-1;bludisko_stena(p,s,t,n,l,drevo);
	p[0] = 1;bludisko_stena(p,s,t,n,l,drevo);
	p[2] =-1;
	p[0] =-1;bludisko_stena(p,s,t,n,l,drevo);
	p[0] = 0;bludisko_stena(p,s,t,n,l,drevo);
	p[0] = 1;bludisko_stena(p,s,t,n,l,drevo);
	p[0] =-1;
	p[2] =-2;bludisko_stena(p,s,t,n,l,drevo);
	p[2] =-3;bludisko_stena(p,s,t,n,l,drevo);
	p[2] =-4;bludisko_stena(p,s,t,n,l,drevo);
	p[2] =-5;bludisko_stena(p,s,t,n,l,drevo);
	p[2] =-6;bludisko_stena(p,s,t,n,l,drevo);

	if(strela)
	{
		int von=0;

		// kolizia zo stropom a podlahov
		if(str_p.y>0.9f || str_p.y<0.1f)von=1;

		if(str_p.x<-1.9f || str_p.x>1.9f)von = 1;
			if( (str_p.z<-1.9f&& (str_p.x>-0.1f || str_p.x<-0.9f)) || str_p.z>1.9f || str_p.z<-6.9f)von = 1;

		if(str_p.x>-0.1f && str_p.x<1.1f && str_p.z<0.1f && str_p.z>-1.1f)von=1;

		if(str_p.x<-0.9f && (str_p.z>0.9f ||str_p.z<0.1f) )von = 1;
		if(str_p.z>0.9f && str_p.x>-0.1f)von = 1;

		glBlendFunc(GL_ONE,GL_ONE_MINUS_SRC_COLOR);
		glEnable(GL_BLEND);		

		if(von)
		{
			GLfloat LightAmbient[]	=	{ 1.0f, 1.0f, 1.0f, 1.0f };
			GLfloat LightDiffuse[]	=	{ 1.0f+6.f*cas, 1.0f+6.f*cas, 1.0f+6.f*cas, 1.0f };
			glLightModelfv ( GL_LIGHT_MODEL_AMBIENT, LightAmbient );
			glLightfv ( GL_LIGHT0, GL_DIFFUSE, LightDiffuse );
			if(cas==0.01f)
			{
				str_p.x -= rychlost_strely*vd_.x/fps;
				str_p.y -= rychlost_strely*vd_.y/fps;
				str_p.z -= rychlost_strely*vd_.z/fps;
			}
			s[0] = 1.5f*cas*c->vr.x;
			s[1] = 1.5f*cas*c->vr.y;
			s[2] = 1.5f*cas*c->vr.z;
			t[0] = 1.5f*cas*c->vu.x;
			t[1] = 1.5f*cas*c->vu.y;
			t[2] = 1.5f*cas*c->vu.z;
			p[0] = str_p.x-0.5f*s[0]-0.5f*t[0];
			p[1] = str_p.y-0.5f*s[1]-0.5f*t[1];
			p[2] = str_p.z-0.5f*s[2]-0.5f*t[2];

			glBindTexture(GL_TEXTURE_2D,strela_dopad );
			Stvorec(p,s,t,n);


			cas += 2.0f/fps;
		}
		else
		{
			GLfloat LightAmbient[]	=	{ 0.0f, 0.0f, 0.0f, 0.0f };
			GLfloat LightDiffuse[]	=	{ 1.5f, 1.5f, 1.5f, 1.0f };
			glLightModelfv ( GL_LIGHT_MODEL_AMBIENT, LightAmbient );
			glLightfv ( GL_LIGHT0, GL_DIFFUSE, LightDiffuse );

			s[0] = 0.2f*c->vr.x;
			s[1] = 0.2f*c->vr.y;
			s[2] = 0.2f*c->vr.z;
			t[0] = 0.2f*c->vu.x;
			t[1] = 0.2f*c->vu.y;
			t[2] = 0.2f*c->vu.z;
			p[0] = str_p.x-0.5f*s[0]-0.5f*t[0];
			p[1] = str_p.y-0.5f*s[1]-0.5f*t[1];
			p[2] = str_p.z-0.5f*s[2]-0.5f*t[2];

			glBindTexture(GL_TEXTURE_2D,t_svetlo );
			Stvorec(p,s,t,n);
			str_p.x += rychlost_strely*vd_.x/fps;
			str_p.y += rychlost_strely*vd_.y/fps;
			str_p.z += rychlost_strely*vd_.z/fps;
		}
		glDisable(GL_BLEND);

		if(cas>0.5f)
		{
			GLfloat LightAmbient[]	=	{ 0.3f, 0.3f, 0.3f, 0.3f };
			GLfloat LightDiffuse[]	=	{ 1.0f, 1.0f, 1.0f, 1.0f };
			glLightModelfv ( GL_LIGHT_MODEL_AMBIENT, LightAmbient );
			glLightfv ( GL_LIGHT0, GL_DIFFUSE, LightDiffuse );
			strela = 0;
			cas = 0;
		}
	}
	glLightf( GL_LIGHT0, GL_CONSTANT_ATTENUATION,  1.0f);
	glLightf( GL_LIGHT0, GL_LINEAR_ATTENUATION,    0.0f);
	glLightf( GL_LIGHT0, GL_QUADRATIC_ATTENUATION, 0.0f);

	Prepni_do_2D();
	font0->Begin();
	fps = 1.0f / timer0.GetTime();
	timer0.Reset();
	fps_counter.GetAvgFps(1.f/fps,0.2f);
	gcvt( (double)fps_counter.avg_fps, 4, text);
	font0->Print(0,0,text,0);				// vypisanie textu na 0 stlpec a 0 riadok

	glColor3f(1,0,0);
	if(multitextureSupported&&multi)font0->Print(0,1,"Multitexturing",0);
	glColor3f(1,1,1);

	if(keys['H'])							// zobrazenie helpu
	{
		int i=3;
		glDisable(GL_TEXTURE_2D);
		glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
		glColor4f(0,0,0,0.3f);
		glLoadIdentity();
		glBegin(GL_QUADS);
			glVertex2i(55,295);
			glVertex2i(800,295);
			glVertex2i(800,555);
			glVertex2i(55,555);
		glEnd();
		glColor4f(1,1,1,1);
		glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_COLOR);
		glEnable(GL_TEXTURE_2D);

		if(english)
		{
			font0->Print(10,i++,"Program: Bump-mapping - labyrinth",0);
			glColor3f(0.9f,0.9f,1.0f);
			font0->Print(5,i++,"Programmer: Marek Mizanin - www.mizanin.szm.sk",0);
			glColor3f(1.0f,1.0f,1.0f);
			font0->Print(5,i++,"Controls:",0);
			font0->Print(10,i++,"1 - switch to explanation how work emboss bump-mapping",1);
			font0->Print(10,i++,"2 - switch to example bump-mapping with point light",1);
			font0->Print(10,i++,"3 - switch to labyrinth with bump-mapping",1);
			font0->Print(10,i++,"4 - planet with bump-mapping",1);
			i++;
		//	font0->Print(10,i++,"  - pre kazde cislo su odlisne klavesi (odlisne helpi)",1);
			font0->Print(10,i++,"E - on/off emboss, don't show base texture",1);
			font0->Print(10,i++,"B - off/on bump-mapping",1);
			font0->Print(10,i++,"M - on/off multitexturing",1);
			font0->Print(10,i++,"P - on/off draw lines",1);
			font0->Print(10,i++,"L - on/off lighting",1);
			glColor3f(1,0.4f,0.4f);
			font0->Print(10,i++,"Enter, or both mouse button - gunshot (slow flying light)",1);
			glColor3f(1,1,1);
			font0->Print(10,i++,"Shift and gunshot - 10-times faster shot",1);
		}
		else
		{
			font0->Print(10,i++,"Program: Bump-mapping - bludisko",0);
			glColor3f(0.9f,0.9f,1.0f);
			font0->Print(5,i++,"Naprogramoval: Marek Mizanin - www.mizanin.szm.sk",0);
			glColor3f(1.0f,1.0f,1.0f);
			font0->Print(5,i++,"Pouzivane klavesy:",0);
			font0->Print(10,i++,"1 - prepne na vysvetlenie ako funguje emboss bump-mapping",1);
			font0->Print(10,i++,"2 - prepne na ukazku bump-mappingu so bodovym svetlom",1);
			font0->Print(10,i++,"3 - prepne bludisko s bump-mappingom",1);
			font0->Print(10,i++,"4 - planeta s bump-mappingom",1);
			font0->Print(10,i++,"  - pre kazde cislo su odlisne klavesi (odlisne helpi)",1);
			font0->Print(10,i++,"E - zapne/vypne emboss,t.j. nezobraziuje zakladnu texturu",1);
			font0->Print(10,i++,"B - vypne/zapne bump-mapping",1);
			font0->Print(10,i++,"M - zapne/vypne multitexturing",1);
			font0->Print(10,i++,"P - zapne/vypne zobrazovanie ciar",1);
			font0->Print(10,i++,"L - zapne/vypne svetlo",1);
			glColor3f(1,0.4f,0.4f);
			font0->Print(10,i++,"Enter,alebo obidve tlacitka - vystrel (pomaly letiace svetlo)",1);
			glColor3f(1,1,1);
			font0->Print(10,i++,"Shift a vystrel - 10-krat rychlejsi let strely",1);
		}

		font0->Print(10,i++,"H - help",1);
	}
	font0->End();
}