// camera_bludisko.cpp: implementation of the camera_bludisko class.
//
//////////////////////////////////////////////////////////////////////

#include "camera_bludisko.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

camera_bludisko::camera_bludisko()
{
	Reset();		// novy reset

}

camera_bludisko::~camera_bludisko()
{

}

void camera_bludisko::Reset(void)
{
	vp.x=-0.5f;vp.y=0.5f;vp.z=1.5f;
	vd.x=0;vd.y=0;vd.z=-1;
	vu.x=0;vu.y=1;vu.z=0;
	vr.x=1;vr.y=0;vr.z=0;
}

void camera_bludisko::MoveWorld(float fps,Mode mod)
{
	POINT MouseBod;

	float mys_x,mys_y,step;

	if(keys[VK_SHIFT])step=0.50f/fps;else step=2.50f/fps;
	
	if(keys['R']){	Reset(); keys['R']=0; }

	if (keys[VK_UP] || keys[VK_LBUTTON]) Translate(0,0,step);
	if (keys[VK_DOWN] || keys[VK_RBUTTON])Translate(0,0,-step);

	GetCursorPos(&MouseBod);
	SetCursorPos(screen_x/2,screen_y/2);
	mys_x = ((float)MouseBod.x - (float)screen_x/2)/200.0f;
	mys_y = ((float)MouseBod.y - (float)screen_y/2)/200.0f;
	
	if		(keys[VK_NEXT])	mys_y +=-0.5f * step;			//Page Down
	else if(keys[VK_PRIOR])	mys_y += 0.5f * step;			//Page Up
	if		(keys[VK_RIGHT])mys_x += 0.5f * step;
	else if(keys[VK_LEFT])	mys_x +=-0.5f * step;
	
	if(mod==Walk || mod==walk)WalkRotate( mys_x, -mys_y, 0);
	else FlyRotate( mys_x, -mys_y, 0);
	DerivateMatrix();
}

void camera_bludisko::Translate(float x,float y,float z)
{
// funkcia posunie suradnicovy sustavu tak, ze ak 
// x > 0 posun do lava, y > 0 posun dole, z > 0 posun do obrazovky (v smere vd)
	int von=0;
	XYZ p;

	p.x = vp.x;
	p.y = vp.y;
	p.z = vp.z;

	vp.x += x*vr.x + y*vu.x + z*vd.x;
	vp.y += x*vr.y + y*vu.y + z*vd.y;
	vp.z += x*vr.z + y*vu.z + z*vd.z;

	// kolizia zo stropom a podlahov
	if(vp.y>0.9f || vp.y<0.1f)von=1;

	if(vp.x<-1.9f || vp.x>1.9f)von = 1;
	if( (vp.z<-1.9f&& (vp.x>-0.1f || vp.x<-0.9f)) || vp.z>1.9f || vp.z<-6.9f)von = 1;

	if(vp.x>-0.1f && vp.x<1.1f && vp.z<0.1f && vp.z>-1.1f)von=1;	// vo vnutornom stvorci

	if(vp.x<-0.9f && (vp.z>0.9f ||vp.z<0.1f) )von = 1;
	if(vp.z>0.9f && vp.x>-0.1f)von = 1;
	
	if(von)
	{
		vp.x = p.x;
		vp.y = p.y;
		vp.z = p.z;
	}
}